type variable = string;;

type primitive_operator_name = string;;

type type_ =
  | TInt
  | TBool
(*  | TUnit *)
  | TPair of type_ * type_
  | TFunction of type_ * type_;;

type value =
  | VInt of int
  | VBool of bool
  | VPair of value * value
  | VClosure of environment * variable * expression

and expression =
  | EValue of value 
  | EVariable of variable
  | ELambda of variable * type_ * expression
  | EApply of expression * expression
  | EUnaryPrimitive of primitive_operator_name * expression
  | EBinaryPrimitive of expression * primitive_operator_name * expression
  | EIf of expression * expression * expression
  | ELet of variable * type_ * expression * expression

and environment =
    value Environment.environment;;

type local_environment = environment;;
type global_environment = environment;;

type toplevel_form =
  | TDefine of variable * expression
  | TDeclare of variable * type_;;

type program =
  | PExpression of expression
  | PNonTrivial of toplevel_form * program;;
