open Domains;;

let rec string_of_value v =
  match v with
    | VInt i ->
      string_of_int i
    | VBool b ->
      if b then "True" else "False"
    | VPair(left, right) ->
      "(" ^ (string_of_value left) ^ ", " ^ 
        (string_of_value right) ^ ")"
    | VClosure _ ->
      "#<closure>";;

let rec string_of_type t =
  match t with
    | TInt ->
      "int"
    | TBool ->
      "bool"
    | TPair(left_type, right_type) ->
      "(" ^ (string_of_type left_type) ^ " * " ^ 
        (string_of_type right_type) ^ ")"
    | TFunction(from_type, to_type) ->
      "(" ^ (string_of_type from_type) ^ " -> " ^ 
        (string_of_type to_type) ^ ")";;

